<div [class]="detailClass()">
    <div class="col-12 col-md-8">

        <ng-container *transloco="let t; prefix: ''">

            <div class="row text-break">
                <h1 class="text-primary">{{ t(title()) }}</h1>
            </div>
            @if(showEditButton() && !edit()) {
            <div class="row my-4">
                <div class="col-auto">
                    <button mat-flat-button id="editButton" color="accent"
                        (click)="editAction()"><mat-icon>edit</mat-icon> {{
                        t(editButtonEditLabel()) }}</button>
                </div>
                <div class="ms-auto col-auto">
                    @for (button of extraButtons(); track button) {
                    <button mat-flat-button [color]="button.type"
                        (click)="button.action()"><mat-icon>{{button.icon}}</mat-icon> {{
                        t(button.label) }}</button>
                    }
                </div>
            </div>
            }

            @if(!edit()) {
            <div class="row">
                @for (entity of (entity() | keyvalue : noSort); track entity) {
                <div [class]="columnClass()">
                    <div class="row pb-1" [id]="'label-'+entity.key">
                        <div class="col fw-semibold">{{ t(entity.value.label) }}</div>
                    </div>
                    <div class="row pb-3" [id]="'value-'+entity.key">
                        <div class="col">{{ entity.value }}</div>
                    </div>
                </div>
                }
            </div>
            } @else {
            <form id="editForm" [formGroup]="formGroup()" (submit)="$event.preventDefault(); saveAction()">

                        <div class="row">
                            @for (detailForm of (editForm() | keyvalue: noSort); track detailForm) {
                            @if (isTextDetail(detailForm); as textDetailForm) {
                            <div class="col-12">
                                <div class="mb-3">
                                    <label [id]="'label-'+detailForm.key" [for]="detailForm.key" class="form-label">{{
                                        t(detailForm.value.label)
                                        }}</label>
                                    <input [name]="detailForm.key" type="text" class="form-control"
                                        [id]="'input-'+detailForm.key" [formControlName]="detailForm.key"
                                        [class.is-invalid]="wasValidated() && !formGroup().get(detailForm.key)?.valid"
                                        [class.is-valid]="wasValidated() && formGroup().get(detailForm.key)?.valid">
                                </div>
                            </div>
                            }
                            @if (isbooleanDetail(detailForm); as booleanDetailForm) {
                            <div class="col-12">
                                <div class="mb-3 form-check">
                                    <input [name]="detailForm.key" type="checkbox" class="form-check-input"
                                        [id]="'input-'+booleanDetailForm.key" [formControlName]="detailForm.key">
                                    <label class="form-check-label" [id]="'label-'+booleanDetailForm.key"
                                        [for]="booleanDetailForm.key">{{t(booleanDetailForm.value.label)}}</label>
                                </div>
                            </div>
                            }
                            }
                        </div>
                        <div class="row mt-3 justify-content-md-center">
                            <button type="submit" id="submitButton" mat-flat-button class="col-lg-2 mx-2 mb-1 p-3"
                                color="accent"><mat-icon>save</mat-icon> {{t('simpleInput.save')}}</button>
                            @if (!hideCancelButton()) {
                            <button type="button" id="cancelButton" mat-flat-button class="col-lg-2 mx-2 mb-1 p-3"
                                color="secondary" (click)="cancelAction()"><mat-icon>close</mat-icon>
                                {{t('simpleInput.cancel')}}</button>
                            }
                        </div>
            </form>
            }
        </ng-container>
    </div>
</div>
